{%- import "shuup_definite_theme/product_list_macros.jinja" as product_list_macros with context %}

{% macro product_box(product,
        show_image=True,
        show_description=True,
        class="product-box",
        thumbnail_size=(200,200),
        show_user_actions=True,
        show_actions=False,
        supplier=None) %}

    {% set shop_product = product.get_shop_instance(request.shop, allow_cache=True) %}
    {% if supplier %}
        {% set u = url("shuup:supplier-product", supplier_pk=supplier.pk, pk=product.pk, slug=product.slug) %}
    {% else %}
        {% set u = url("shuup:product", pk=product.pk, slug=product.slug) %}
        {% set supplier = shop_product.get_supplier() %}
    {% endif %}

    {% set show_supplier_info = (supplier and xtheme.get("show_supplier_info")) %}

    <div class="product-card {{ class }} {{ 'load-on-hover' if show_actions else '' }}" id="product-{{ product.id }}">
        <div class="render-on-hover"></div>
        <a href="{{ u }}" rel="product-detail" title="{{ product.name }}">
            {% if product|is_discounted(supplier=supplier) %}
                <div class="labels">
                    <span class="label label-sale">{{ -(product|discount_rate(supplier=supplier))|percent }}</span>
                </div>
            {% elif xtheme.product_is_new(request, product) %}
                <div class="labels">
                    <span class="label label-new">{% trans %}New{% endtrans %}</span>
                </div>
            {% endif %}
            <div class="image-wrap">
                {% if show_image %}
                    {% set product_image = shop_product.public_primary_image or shop_product.public_images.first() %}
                    {% set primary_image_thumb = product_image|thumbnail(size=thumbnail_size) %}
                    {% if product_image and primary_image_thumb %}
                        {% set image_url = primary_image_thumb %}
                    {% else %}
                        {% set image_url = STATIC_URL ~ "shuup/front/img/no_image.png" %}
                    {% endif %}
                    <div class="image" style="background-image:url('{{ image_url }}')"></div>
                {% endif %}
                <div class="user-actions">
                    {% if show_user_actions %}
                        {{ render_user_actions(shop_product) }}
                    {% endif %}
                </div>
            </div>
            <div class="detail-wrap">
                <div class="name">
                    {{ product.name }}
                </div>
                <div class="actions-wrap">
                    {% if show_prices() and not xtheme.get("hide_prices") %}
                        <div class="price">
                            {{ render_product_price(product, show_units=False, supplier=supplier) }}
                        </div>
                    {% endif %}
                    {% if show_user_actions %}
                        <div class="user-list-actions">
                            {{ render_user_actions(shop_product) }}
                        </div>
                    {% endif %}
                </div>
                {% if show_description and product.short_description %}
                    <div class="description">{{ product.short_description|safe_product_description }}</div>
                {% endif %}
                {# we can't render a link here as this is already insde an anchor #}
                {% if show_supplier_info %}
                    {{ render_supplier_info(supplier, render_link=False) }}
                {% endif %}
                {% if shop_product and shop_product.available_until %}
                    {{ render_availability_info(shop_product) }}
                {% endif %}
                {% if xtheme.get("show_product_review") %}
                    {{ xtheme.render_product_review_rating(product, minified=True) }}
                {% endif %}
                {{ xtheme.render_extra_product_card_content(product, shop_product, supplier)|safe }}
            </div>
        </a>
        {% if show_actions %}
            <div class="actions-sync actions">
                {% include "shuup_definite_theme/product/product_actions.jinja" %}
            </div>
        {% endif %}
    </div>
{% endmacro %}

{% macro render_product_basic_information(shop_product, product, supplier=None) %}
    {% set is_orderable = shop_product.is_orderable(supplier=None, customer=request.customer, quantity=1) %}
    {% set show_supplier_info = (supplier and xtheme.get("show_supplier_info")) %}

    <h1 class="product-name">{{ product.name }}</h1>
    {%  if show_supplier_info %}{{ render_supplier_info(supplier) }}{% endif %}

    {% if product.description and not xtheme.should_render_product_detail_tab("description") %}
        <p class="product-short-description">
            {% if product.description or package_children %}
                <div class="product-description-content">
                    {{ product.description|safe_product_description }}
                </div>
                {% if package_children %}
                    {% set quantity_map = product.get_package_child_to_quantity_map() %}
                    <p><strong>{% trans %}Includes these products{% endtrans %}</strong></p>
                    <ul>
                        {% for child in package_children %}
                            <li>
                                {{ product_line(child, quantity_map[child]) }}
                            </li>
                        {% endfor %}
                    </ul>
                {% endif %}
            {% else %}
                {% trans %}No product description available{% endtrans %}
            {% endif %}
        </p>
    {% endif %}
    {% if show_prices() and not xtheme.get("hide_prices") %}
        <div class="product-price">
            {{ render_product_price(product, supplier=supplier) }}
        </div>
    {% endif %}
{% endmacro %}

{% macro render_user_actions(shop_product) %}
    {% if shuup.urls.has_url("shuup:comparison_view") %}
        <div class="action">
        {{ xtheme.get_comparison_button(shop_product.product) }}
        </div>
    {% endif %}
    {% if shuup.urls.has_url("shuup:personal_wishlists") %}
        <div class="action">
        {% set wishlist_url = url("shuup:login") if request.customer.is_anonymous else "" %}
        {{ xtheme.get_wishlist_button(shop_product, wishlist_url) }}
        </div>
    {% endif %}
{% endmacro %}
